{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 4096,0,5}

{ (C) ᮢ .., , 1995 }

unit TextVM;

interface

  uses Dos,Crt;

  const v__buf = $b800;

  var constwide,subwide,wi__ : byte;
      l__,r__,hi__,lo__      : array[1..10] of byte;
      cline__                : word;
      oldwindmin,oldwindmax  : array[1..10] of word;

  procedure Cls(c__sc,b__sc : byte);
  procedure SetVMA;
  procedure Set8B;
  procedure Set16B;
  procedure Sym(x__sc,y__sc,mcolor,msymbol : byte);
  procedure GetText(left_,high_,right_,low_ : byte; var sw);
  procedure PutText(left_,high_,right_,low_ : byte; var sw);
  procedure Neg(left_,high_,right_,low_ : byte);
  procedure Shadow(left_,high_,right_,low_,dead_ : byte; var sw);
  procedure Print(x__t,y__t,c__t : byte; s__t : string; l__p : byte);
  procedure TextLine(startX : shortint; startY,long,col,typ : byte);
  procedure Room(left_,high_,right_,low_,c__r,t__r : byte);
  procedure CursorOn;
  procedure CursorOff;
  procedure SetCursor(s__lc,e__lc : byte);
  procedure SetTextPage(x__sc : byte);
  procedure ScrollUp;
  procedure ScrollDn;
  procedure Board(left_,high_,right_,low_,c__r : byte);
  procedure Menu(left_,high_,right_,low_,c__b,c__r,t__r : byte; var sw);
  procedure MenuOff(var sw);
  procedure WriteText(s__sc : string);
  procedure MovePage(s__sc,d__sc : byte);
  procedure SetBorder(c__b : byte);
  procedure SetTxtColor(left,high,right,low,col : byte);
  procedure SetGrColor(left,high,right,low,col : byte);

  function Page : byte;
  function Wide : byte;
  function TSC(x__sc,y__sc : byte; s__sc : char) : byte;
  function TextBufSize(x,y,x1,y1 : byte) : word;
  function Adress(var x,y : byte) : integer;

Implementation

  procedure Cls;
  var  r  : registers;
       ta : byte;
  begin
    ta:=(b__sc shl 4)+c__sc;
    with r do begin
      cx:=windmin;
      dx:=windmax;
      ax:=$600;
      bh:=ta;
      Intr($10,r);
      TextAttr:=BH;
      AH:=2;
      DX:=windmin;
      BH:=Page;
      Intr($10,r);
    end { with };
    GotoXY(1,1);
  end { Cls };

  function Page; assembler;
  asm
      mov AH,$0F
      int $10
      mov AL,BH
  end;

  function Adress;
  begin
    Adress:=(x+y*constwide-subwide) shl 1;
  end { Adress };

  function InScreen(x,y : byte) : boolean; near; assembler;
  asm
           cmp y,1
            jl @no
           cmp x,1
            jl @no
           cmp y,25
            ja @no
           mov AL,constwide.TextVM
           cmp x,AL
           jna @ex
      @no: xor AL,AL
      @ex:
  end { InScreen };

  function TSC;
  var  fpk : integer;
  begin
    if not InScreen(x__sc,y__sc) then Exit;
    s__sc:=UpCase(s__sc);
    fpk:=Adress(x__sc,y__sc);
    case s__sc of
      'S' :  TSC:=mem[SegB800:fpk];
      'A' :  TSC:=mem[SegB800:fpk+1];
      'C' :  TSC:=mem[SegB800:fpk+1] and $f;
      'B' :  TSC:=mem[SegB800:fpk+1] shr 4;
    end { select };
  end { TSC };

  function Wide; assembler;
  asm
     mov AH,15
     int $10
     mov AL,AH
  end { Wide };

  procedure SetVMA;
  begin
    constwide:=Wide;
    subwide:=constwide+1;
    case constwide of
      40 : SegB800:=v__buf+$80*Page;
      80 : SegB800:=v__buf+$100*Page;
    end { case };
  end { SetVMA };

  procedure SetTxtColor;
  var x,y,m : byte;
      fpk   : word;
  begin
    if not (InScreen(left,high) and InScreen(right,low)) then Exit;
    SetVMA;
    for x:=left to right do
      for y:=high to low do begin
        fpk:=Adress(x,y)+1;
        m:=mem[SegB800:fpk];
        mem[SegB800:fpk]:=m and $F0 or col;
    end { for };
  end { SetTxtColor };

  procedure SetGrColor;
  var x,y,m : byte;
      fpk   : word;
  begin
    if not (InScreen(left,high) and InScreen(right,low)) then Exit;
    SetVMA;
    for x:=left to right do
      for y:=high to low do begin
        fpk:=Adress(x,y)+1;
        m:=mem[SegB800:fpk];
        mem[SegB800:fpk]:=m and $F or (col shl 4);
    end { for };
  end { SetGrColor };

  procedure Sym;
  var  fpk : integer;
  begin
    if not InScreen(x__sc,y__sc) then Exit;
    fpk:=Adress(x__sc,y__sc);
    mem[SegB800:fpk+1]:=mcolor;
    mem[SegB800:fpk]:=msymbol;
  end { Sym };

  procedure Set8B; assembler;
  asm
     mov AX,$1003
     mov BL,1
     int $10
  end { Set8B };

  procedure Set16B; assembler;
  asm
     mov AX,$1003
     mov BL,0
     int $10
  end { Set16B };

  procedure GetText;
  var s         : array [1..2048] of word absolute sw;
      r	        : registers;
      x,y	: byte;
      fpk,l	: integer;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    SetVMA; l:=0;
    for x:=left_ to right_ do
      for y:=high_ to low_ do begin
     	fpk:=Adress(x,y); inc(l);
	     s[l]:=(mem[SegB800:fpk+1] shl 8) or mem[SegB800:fpk];
    end { for };
  end { GetText };

  procedure PutText;
  var x,y   : byte;
      l,fpk : integer;
      s     : array [1..2048] of word absolute sw;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    SetVMA; l:=1;
    for x:=left_ to right_ do
      for y:=high_ to low_ do begin
         fpk:=Adress(x,y);
         memw[SegB800:fpk]:=s[l]; inc(l);
    end { for };
  end { PutText };

  procedure Neg;
  var x,y,p  : byte;
      fpk,fp : integer;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    SetVMA;
    for x:=left_ to right_ do
      for y:=high_ to low_ do begin
	    fpk:=Adress(x,y)+1;
	    fp:=mem[SegB800:fpk];
	    mem[SegB800:fpk]:=fp shl 4 or fp shr 4;
    end { for };
  end { Neg };

  procedure Shadow;
  var x,y,r1,l1 : byte;
      fpk       : integer;
      s         : array [1..2048] of word absolute sw;
  begin
    l1:=low_+1; r1:=right_+1;
    if not (InScreen(left_,high_) and InScreen(r1,l1)) then Exit;
    case dead_ of
      1 : begin
	    GetText(left_,high_,r1,l1,s);
	    for x:=left_+1 to r1 do
           for y:=high_+1 to l1 do begin
              fpk:=Adress(x,y)+1;
              mem[SegB800:fpk]:=mem[SegB800:fpk] and 7;
	    end { for };
	  end { 1 };
      0 : PutText(left_,high_,r1,l1,s);
    end { case };
  end { Shadow };

  procedure TextLine;
  const lh : array[1..10, 1..3] of byte = ((195,196,180),
                                           (198,205,181),
                                           (199,196,182),
                                           (204,205,185),
                                           (176,176,176),
                                           (177,177,177),
                                           (178,178,178),
                                           (219,219,219),
                                           (196,196,196),
                                           (205,205,205));
        lv : array[1..10, 1..3] of byte = ((194,179,193),
                                           (210,186,208),
                                           (209,179,207),
                                           (203,186,202),
                                           (176,176,176),
                                           (177,177,177),
                                           (178,178,178),
                                           (219,219,219),
                                           (179,179,179),
                                           (186,186,186));
  var i,st,en : byte;
  begin
     SetVMA;
     st:=Abs(startX);
     if startX>0 then begin
        en:=st+long-1;
        if not (InScreen(st,startY) and InScreen(en,startY)) then Exit;
        for i:=st+1 to en-1 do
          Sym(i,startY,(col or (TSC(i,startY,'b') shl 4)),lh[typ,2]);
        Sym(st,startY,(col or (TSC(st,startY,'b') shl 4)),lh[typ,1]);
        Sym(en,startY,(col or (TSC(en,startY,'b') shl 4)),lh[typ,3]); end
     else begin
        en:=startY+long;
        if not (InScreen(st,startY) and InScreen(st,en)) then Exit;
        for i:=startY+1 to en-1 do
          Sym(st,i,(col or (TSC(st,i,'b') shl 4)),lv[typ,2]);
        Sym(st,startY,(col or (TSC(st,startY,'b') shl 4)),lv[typ,1]);
        Sym(st,en,(col or (TSC(st,en,'b') shl 4)),lv[typ,3]);
     end { if };
  end { TextLine };

  procedure Room;
  const rm : array [1..8, 1..6] of byte =
	     ((218,196,191,179,217,192),
	      (213,205,184,179,190,212),
	      (214,196,183,186,189,211),
	      (201,205,187,186,188,200),
	      (176,176,176,176,176,176),
	      (177,177,177,177,177,177),
	      (178,178,178,178,178,178),
	      (219,219,219,219,219,219));
  var i : byte;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    SetVMA;
    for i:=left_+1 to right_-1 do begin
      sym(i,high_,(c__r or (TSC(i,high_,'b') shl 4)),rm[t__r,2]);
      sym(i,low_,(c__r or (TSC(i,low_,'b') shl 4)),rm[t__r,2]);
    end { for };
    for i:=high_+1 to low_-1 do begin
      sym(left_,i,(c__r or (TSC(left_,i,'b') shl 4)),rm[t__r,4]);
      sym(right_,i,(c__r or (TSC(right_,i,'b') shl 4)),rm[t__r,4]);
    end { for };
    sym(left_,high_,(c__r or (TSC(left_,high_,'b') shl 4)),rm[t__r,1]);
    sym(right_,high_,(c__r or (TSC(right_,high_,'b') shl 4)),rm[t__r,3]);
    sym(right_,low_,(c__r or (TSC(right_,low_,'b') shl 4)),rm[t__r,5]);
    sym(left_,low_,(c__r or (TSC(left_,low_,'b') shl 4)),rm[t__r,6]);
  end { Room };

  procedure Print;
  var i,p,pw,xw : byte;
  begin
    if not InScreen(x__t,y__t) then Exit;
    SetVMA;
    p:=length(s__t); xw:=x__t; pw:=l__p;
    for i:=1 to p do begin
      sym(xw,y__t,((TSC(xw,y__t,'b') shl 4) or c__t),ord(s__t[i]));
      dec(pw); inc(xw);
      if pw=0 then begin
	xw:=x__t; pw:=l__p; inc(y__t);
      end { if };
    end { for };
  end { Print };

  procedure CursorOff;
  var r : registers;
  begin
    with r do begin
      AH:=3;
      BH:=Page;
      Intr($10,r);
      cline__:=CX;
      CH:=$20;
      AH:=1;
      intr($10,r);
    end { r };
  end { CursorOff };

  procedure CursorOn;
  var r : registers;
  begin
    with r do begin
      BH:=Page;
      AH:=1;
      CX:=cline__;
      intr($10,r);
    end { r };
  end { CursorOn };

  procedure SetCursor;
  var r   : registers;
  begin
    with r do begin
      AH:=1;
      CL:=e__lc;
      CH:=s__lc;
      cline__:=CX;
      Intr($10,r);
    end { r };
  end { SetCursor };

  procedure SetTextPage;
  begin
    asm
       mov AH,5
       mov AL,x__sc;
       int $10;
    end;
    SetVMA;
  end { SetTextPage };

  procedure scroll(r : registers);
  begin
    with r do begin
      bh:=TextAttr shr 4;
      cx:=windmin;
      dx:=windmax;
      al:=1;
    end { with };
    intr($10,r);
  end { scroll };

  procedure ScrollUp;
  var r : registers;
  begin
    r.ah:=6; scroll(r);
  end { ScrollUp };

  procedure ScrollDn;
  var r : registers;
  begin
    r.ah:=7; scroll(r);
  end { ScrollDn };

  procedure Board;
  var i,j,c : byte;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    c:=c__r shl 4;
    for i:=left_ to right_ do
      for j:=high_ to low_ do sym(i,j,c,32);
  end { Board };

  procedure Menu;
  var s : array[1..2048] of word absolute sw;
  begin
    if not (InScreen(left_,high_) and InScreen(right_,low_)) then Exit;
    inc(wi__);
    l__[wi__]:=left_; r__[wi__]:=right_;
    lo__[wi__]:=low_; hi__[wi__]:=high_;
    oldwindmin[wi__]:=windmin; oldwindmax[wi__]:=windmax;
    Shadow(left_,high_,right_,low_,1,s);
    Board(left_,high_,right_,low_,c__b);
    Room(left_,high_,right_,low_,c__r,t__r);
    Window(left_+1,high_+1,right_-1,low_-1);
  end { menu };

  procedure MenuOff;
  var s : array[1..2048] of word absolute sw;
  begin
    Shadow(l__[wi__],hi__[wi__],r__[wi__],lo__[wi__],0,s);
    Window((Lo(oldwindmin[wi__])+1),(Hi(oldwindmin[wi__])+1),
	   (Lo(oldwindmax[wi__])+1),(Hi(oldwindmax[wi__])+1));
    Dec(wi__);
  end { MenuOff };

  procedure WriteText;
  var r : registers;
  begin
    with r do begin
      AH:=3;
      BH:=Page;
      Intr($10,r);
      ES:=seg(s__sc);
      BP:=ofs(s__sc)+1;
      CX:=length(s__sc);
      BH:=page;
      BL:=TextAttr;
      AX:=$1301;
      Intr($10,r);
    end { with };
  end { WriteText };

  procedure MovePage;
  var i,fpk,soursegm,destsegm,wd : integer;
  begin
    case wide of
      40 : begin
	     soursegm:=v__buf+$80*s__sc;
	     destsegm:=v__buf+$80*d__sc;
	     wd:=2000;
	   end { 40 };
      80 : begin
	     soursegm:=v__buf+$100*s__sc;
	     destsegm:=v__buf+$100*d__sc;
	     wd:=4000;
	   end { 80 };
    end { select };
    fpk:=0;
    while fpk<wd do begin
      memw[destsegm:fpk]:=memw[soursegm:fpk];
      inc(fpk,2);
    end { while };
  end { MovePage };

  procedure SetBorder; assembler;
  asm
     mov AX,$1001
     mov BH,c__b
     int $10
  end { SetBorder };

  function TextBufSize;
  begin
    if InScreen(x,y) and InScreen(x1,y1) and (x1>=x) and (y1>=y) then
       TextBufSize:=((x1-x+2) * (y1-y+2)) shl 1
    else TextBufSize:=0;
  end { TextBufSize };

begin
  wi__:=0;
  cline__:=$607;
  SetVMA;
end.












